@Book{a-little-smalltalk,
 author = {Budd, Timothy},
 title = {A little Smalltalk},
 publisher = {Addison-Wesley Longman Publishing Co., Inc.},
 year = 1987,
 isbn = 0201106981
}

@Article{accelerating-hindsight,
 author = {Pitman, Kent M.},
 title = {Accelerating Hindsight: Lisp as a Vehicle for Rapid Prototyping},
 journal = {SIGPLAN Lisp Pointers},
 year = 1994,
 volume = {VII},
 number = {1–2},
 pages = {14–21},
 month = jan,
 issue_date = {Jan.-March/April-June 1994},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {1045-3563},
 url = {https://doi.org/10.1145/192590.192598},
 doi = {10.1145/192590.192598},
 numpages = 8
}

@Book{ansi:common:lisp,
 title = {INCITS 226-1994[S2008] Information Technology, Programming Language, Common Lisp},
 publisher = {American National Standards Institute},
 year = 1994
}

@PhdThesis{armstrong2003making,
 author = {Armstrong, Joe},
 title = {Making reliable distributed systems in the presence of software errors},
 school = {The Royal Institute of Technology Stockholm, Sweden},
 year = 2003
}

@Misc{artoul2015:class-transition,
 author = {Richard Artoul},
 title = "{J}avascript {H}idden {C}lasses and {I}nline {C}aching in {V8}",
 howpublished = "\url{https://richardartoul.github.io/jekyll/update/2015/04/26/hidden-classes.html}, Accessed: 2020-10-28",
 year = 2015
}

@InProceedings{back-to-future-squeak,
 author = {Ingalls, Dan and Kaehler, Ted and Maloney, John and Wallace, Scott and Kay, Alan},
 title = {Back to the Future: The Story of Squeak, a Practical Smalltalk Written in Itself},
 booktitle = {Proceedings of the 12th ACM SIGPLAN Conference on Object-Oriented Programming, Systems, Languages, and Applications},
 year = 1997,
 series = {OOPSLA '97},
 pages = {318–326},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 0897919084,
 url = {https://doi.org/10.1145/263698.263754},
 doi = {10.1145/263698.263754},
 numpages = 9,
 location = {Atlanta, Georgia, USA}
}

@Book{blue-book,
 author = {Goldberg, Adele and Robson, David},
 title = {Smalltalk-80: The Language and Its Implementation},
 publisher = {Addison-Wesley Longman Publishing Co., Inc.},
 year = 1983,
 address = {USA},
 isbn = 0201113716
}

@InProceedings{bracha2010:modules-as-objects,
 author = {Bracha, Gilad and von der Ah\'{e}, Peter and Bykov, Vassili and Kashai, Yaron and Maddox, William and Miranda, Eliot},
 title = {Modules as Objects in {Newspeak}},
 booktitle = {Proceedings of the 24th European Conference on Object-Oriented Programming},
 year = 2010,
 series = {ECOOP'10},
 pages = {405–428},
 address = {Berlin, Heidelberg},
 publisher = {Springer-Verlag},
 note = "\url{http://bracha.org/newspeak-modules.pdf}",
 isbn = 3642141064,
 numpages = 24,
 location = {Maribor, Slovenia}
}

@InProceedings{bracha:does-thought-crime-pay,
 author = {Bracha, Gilad},
 title = {Does Thought Crime Pay?},
 booktitle = {Proceedings of the 2013 Companion Publication for Conference on Systems, Programming, \& Applications: Software for Humanity},
 year = 2013,
 series = {SPLASH '13},
 pages = {7–8},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 9781450319959,
 url = {https://doi.org/10.1145/2508075.2508191},
 doi = {10.1145/2508075.2508191},
 numpages = 2,
 keywords = {objects},
 location = {Indianapolis, Indiana, USA}
}

@InProceedings{bracha:pluggable-type-systems,
 author = {Bracha, Gilad},
 title = {Pluggable Type Systems},
 booktitle = {OOPSLA Workshopon Revival of Dynamic Languages.},
 year = 2004,
 series = {OOPSLA '04},
 month = jan
}

@Article{chambers89:self-implementation,
 author = {Craig Chambers and David Ungar and Elgin Lee},
 title = {An Efficient Implementation of \textsc{{Self}}, a Dynamically-Typed Object-Oriented Language Based on Prototypes},
 journal = {SIGPLAN Not.},
 year = 1989,
 volume = 24,
 number = 10,
 pages = {49–70},
 month = sep,
 issue_date = {Oct. 1989},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {0362-1340},
 url = {https://doi.org/10.1145/74878.74884},
 doi = {10.1145/74878.74884},
 numpages = 22
}

@PhdThesis{chambers92:phd,
 author = {Chambers, Craig},
 title = {The Design and Implementation of the SELF Compiler, an Optimizing Compiler for Object-Oriented Programming Languages},
 school = "The Department of Computer Science and the Committee on Graduate Studies of Stanford University",
 year = 1992,
 month = mar,
 note = "\url{https://www.researchgate.net/publication/2827867_The_Design_and_Implementation_of_the_SELF_Compiler_an_Optimizing_Compiler_for_Object-Oriented_Programming_Languages}, Accessed: 2020-10-15"
}

@Book{compiling-with-continuations,
 author = {Andrew W. Appel},
 title = {Compiling with continuations},
 publisher = {Cambridge University Press},
 year = 1992,
 isbn = {0-521-41695-7}
}

@InProceedings{computer-revolution,
 author = {Kay, Alan},
 title = {The Computer Revolution Hasn't Happened Yet},
 booktitle = {Proceedings of the 12th ACM SIGPLAN Conference on Object-Oriented Programming, Systems, Languages, and Applications},
 year = 1997,
 series = {OOPSLA '97},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 location = {Atlanta, Georgia, USA}
}

@InProceedings{constraining-control,
 author = {Friedman, Daniel P. and Haynes, Christopher T.},
 title = {Constraining Control},
 booktitle = {Proceedings of the 12th ACM SIGACT-SIGPLAN Symposium on Principles of Programming Languages},
 year = 1985,
 series = {POPL '85},
 pages = {245–254},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 0897911474,
 url = {https://doi.org/10.1145/318593.318654},
 doi = {10.1145/318593.318654},
 numpages = 10,
 location = {New Orleans, Louisiana, USA}
}

@InProceedings{continuous-software-trands-and-challanges,
 author = {Fitzgerald, Brian and Stol, Klaas-Jan},
 title = {Continuous Software Engineering and beyond: Trends and Challenges},
 booktitle = {Proceedings of the 1st International Workshop on Rapid Continuous Software Engineering},
 year = 2014,
 series = {RCoSE 2014},
 pages = {1–9},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 9781450328562,
 url = {https://doi.org/10.1145/2593812.2593813},
 doi = {10.1145/2593812.2593813},
 numpages = 9,
 keywords = {Continuous Star, BizDev, DevOps, continuous software engineering},
 location = {Hyderabad, India}
}

@Article{data-abstraction,
 author = {Cook, William R.},
 title = {On understanding data abstraction, revisited},
 journal = {SIGPLAN Not.},
 year = 2009,
 volume = 44,
 number = 10,
 pages = {557–572},
 month = 10,
 issue_date = {October 2009},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {0362-1340},
 url = {https://doi.org/10.1145/1639949.1640133},
 doi = {10.1145/1639949.1640133},
 numpages = 16
}

@InProceedings{doligez-leroy-gc,
 author = {Damien Doligez and Xavier Leroy},
 title = {A concurrent, generational garbage collector for a multithreaded implementation of {ML}},
 booktitle = {POPL 1993: 20th symposium Principles of Programming Languages},
 year = 1993,
 pages = {113--123},
 publisher = {ACM},
 urllocal = {https://xavierleroy.org/publi/concurrent-gc.pdf},
 urlpublisher = {https://doi.org/10.1145/158511.158611},
 doi = {10.1145/158511.158611},
 xtopic = {caml},
 xranking = {top}
}

@Book{dybvig,
 author = {Dybvig, R. Kent},
 title = {The Scheme Programming Language, 4th Edition},
 publisher = {The MIT Press},
 year = 2009,
 edition = {4th},
 isbn = {026251298X}
}

@Misc{enjoy-the-silence,
 author = {{Depeche Mode}},
 title = {Enjoy The Silence},
 year = 1990,
 chapter = 6,
 booktitle = {Violator},
 publisher = {Mute Records}
}

@Article{equal-rights,
 author = {Baker, Henry G.},
 title = {Equal Rights for Functional Objects or, the More Things Change, the More They Are the Same},
 journal = {SIGPLAN OOPS Mess.},
 year = 1993,
 volume = 4,
 number = 4,
 pages = {2–27},
 month = 10,
 issue_date = {Oct. 1993},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {1055-6400},
 url = {https://doi.org/10.1145/165593.165596},
 doi = {10.1145/165593.165596},
 numpages = 26
}

@InProceedings{first-class-global-environments,
 author = {Robert Strandh},
 title = {First-Class Global Environments in Common Lisp},
 booktitle = {Proceedings of the 8th European Lisp Symposium {(ELS} 2015), London, England, April 20-21, 2015},
 year = 2015,
 editor = {Julian A. Padget},
 pages = {79--86},
 publisher = {{ELSAA}},
 url = {https://european-lisp-symposium.org/static/proceedings/2015.pdf\#f},
 timestamp = {Wed, 13 Nov 2019 17:59:17 +0100},
 biburl = {https://dblp.org/rec/conf/els/Strandh15.bib},
 bibsource = {dblp computer science bibliography, https://dblp.org}
}

@Article{fowler2006continuous,
 author = {Fowler, Martin and Foemmel, Matthew},
 title = {Continuous integration},
 journal = {Thought-Works},
 year = 2006,
 volume = 122,
 number = 14,
 pages = {1--7}
}

@TechReport{hash-consing,
 author = {Appel, Andrew W. and Goncalves, Marcelo Jose de Rezende},
 title = {Hash-Consing Garbage Collection},
 institution = {Princeton University},
 year = 1993,
 url = {https://www.cs.princeton.edu/research/techreps/TR-412-93}
}

@InProceedings{history-of-erlang,
 author = {Armstrong, Joe},
 title = {A History of Erlang},
 booktitle = {Proceedings of the Third ACM SIGPLAN Conference on History of Programming Languages},
 year = 2007,
 series = {HOPL III},
 pages = {6–1–6–26},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 9781595937667,
 url = {https://doi.org/10.1145/1238844.1238850},
 doi = {10.1145/1238844.1238850},
 location = {San Diego, California}
}

@Misc{ideal-language,
 author = {Sockwell, Daniel},
 title = {Imagining the Ideal Language for Writing Free Software},
 howpublished = "\url{https://fosdem.org/2021/schedule/event/programming_lang_for_free_software/}",
 year = 2021
}

@Article{immutable-concurrent-copying,
 author = {Huelsbergen, Lorenz and Larus, James R.},
 title = {A Concurrent Copying Garbage Collector for Languages That Distinguish (Im)Mutable Data},
 journal = {SIGPLAN Not.},
 year = 1993,
 volume = 28,
 number = 7,
 pages = {73–82},
 month = jul,
 issue_date = {July 1993},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {0362-1340},
 url = {https://doi.org/10.1145/173284.155340},
 doi = {10.1145/173284.155340},
 numpages = 10
}

@Article{kay2005squeak-etoys,
 author = {Kay, Alan},
 title = {Squeak etoys, children \& learning},
 journal = {online article},
 year = 2005,
 volume = 2006
}

@Article{lazy-alloc,
 author = {Baker, Henry G.},
 title = {\texttt{cons} Should Not \texttt{cons} Its Arguments, or, a Lazy Alloc is a Smart Alloc},
 journal = {SIGPLAN Not.},
 year = 1992,
 volume = 27,
 number = 3,
 pages = {24–34},
 month = 3,
 issue_date = {March 1992},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {0362-1340},
 doi = {10.1145/130854.130858},
 numpages = 11
}

@InProceedings{left-hand-of-equals,
 author = {Noble, James and Black, Andrew P. and Bruce, Kim B. and Homer, Michael and Miller, Mark S.},
 title = {The Left Hand of Equals},
 booktitle = {Proceedings of the 2016 ACM International Symposium on New Ideas, New Paradigms, and Reflections on Programming and Software},
 year = 2016,
 series = {Onward! 2016},
 pages = {224–237},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 9781450340762,
 url = {https://doi.org/10.1145/2986012.2986031},
 doi = {10.1145/2986012.2986031},
 numpages = 14,
 location = {Amsterdam, Netherlands}
}

@Article{machines,
 author = {Eric W. Leaver and John J. Brown},
 title = {Machines without Men},
 journal = {Fortune},
 year = 1946,
 month = 11
}

@Article{maxine,
 author = {Wimmer, Christian and Haupt, Michael and Van De Vanter, Michael L. and Jordan, Mick and Dayn\`{e}s, Laurent and Simon, Douglas},
 title = {Maxine: An Approachable Virtual Machine for, and in, Java},
 journal = {ACM Trans. Archit. Code Optim.},
 year = 2013,
 volume = 9,
 number = 4,
 month = jan,
 issue_date = {January 2013},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {1544-3566},
 url = {https://doi.org/10.1145/2400682.2400689},
 doi = {10.1145/2400682.2400689},
 articleno = 30,
 numpages = 24,
 keywords = {Java, VM design, debugging, tool support, metacircular VM, inspector, Maxine VM, VM interfaces}
}

@Article{miller2008safe,
 author = {Miller, Mark S and Samuel, Mike and Laurie, Ben and Awad, Ihab and Stay, Mike},
 title = {Safe active content in sanitized JavaScript},
 journal = {Google, Inc., Tech. Rep},
 year = 2008
}@masterthesis{Botev2012:msc,author = {Botev, Nikolay},month = 3,year = 2012,school = "San José State University",title = {Actor-based Concurrency in Newspeak 4},note = "\url{https://scholarworks.sjsu.edu/etd_projects/231/}, Accessed: 2020-11-04"}

@Article{mirrors-paper,
 author = {Bracha, Gilad and Ungar, David},
 title = {Mirrors: Design Principles for Meta-Level Facilities of Object-Oriented Programming Languages},
 journal = {SIGPLAN Not.},
 year = 2004,
 volume = 39,
 number = 10,
 pages = {331–344},
 month = oct,
 issue_date = {October 2004},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {0362-1340},
 url = {https://doi.org/10.1145/1035292.1029004},
 doi = {10.1145/1035292.1029004},
 numpages = 14,
 keywords = {smalltalk, self, java, reflection, metaprogramming, mirrors}
}

@Article{monolingual,
 author = {Heering, Jan and Klint, Paul},
 title = {Towards Monolingual Programming Environments},
 journal = {ACM Trans. Program. Lang. Syst.},
 year = 1985,
 volume = 7,
 number = 2,
 pages = {183–213},
 month = 4,
 issue_date = {April 1985},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {0164-0925},
 doi = {10.1145/3318.3321},
 numpages = 31
}

@Article{multiprogrammed-computations,
 author = {Dennis, Jack B. and Van Horn, Earl C.},
 title = {Programming Semantics for Multiprogrammed Computations},
 journal = {Commun. ACM},
 year = 1966,
 volume = 9,
 number = 3,
 pages = {143–155},
 month = mar,
 issue_date = {March 1966},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {0001-0782},
 url = {https://doi.org/10.1145/365230.365252},
 doi = {10.1145/365230.365252},
 numpages = 13
}

@InProceedings{one-vm,
 author = {Würthinger, Thomas and Wimmer, Christian and Wöß, Andreas and Stadler, Lukas and Duboscq, Gilles and Humer, Christian and Richards, Gregor and Simon, Doug and Wolczko, Mario},
 title = {One VM to Rule Them All},
 booktitle = {Proceedings of the 2013 ACM International Symposium on New Ideas, New Paradigms, and Reflections on Programming and Software},
 year = 2013,
 series = {Onward! 2013},
 pages = {187–204},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 9781450324724,
 url = {https://doi.org/10.1145/2509578.2509581},
 doi = {10.1145/2509578.2509581},
 numpages = 18,
 keywords = {language implementation, javascript, java, virtual machine, dynamic languages, optimization},
 location = {Indianapolis, Indiana, USA}
}

@Manual{oracle:jvm-spec,
 title = "The Java Virtual Machine Specification",
 organization = {{O}racle},
 month = feb,
 year = 2015,
 note = "\url{https://docs.oracle.com/javase/specs/jvms/se8/html/index.html}",
 number = "JSR-337"
}

@Article{organising-without-classes,
 author = {Ungar, David and Chambers, Craig and Chang, Bay-Wei and H\"{o}lzle, Urs},
 title = {Organizing Programs without Classes},
 journal = {Lisp Symb. Comput.},
 year = 1991,
 volume = 4,
 number = 3,
 pages = {223–242},
 month = jul,
 issue_date = {July 1991},
 publisher = {Kluwer Academic Publishers},
 address = {USA},
 issn = {0892-4635},
 url = {https://doi.org/10.1007/BF01806107},
 doi = {10.1007/BF01806107},
 numpages = 20
}

@Misc{paxos,
 author = {Lamport, Leslie},
 title = {The {Paxos} algorithm, or how to win a {Turing} award},
 howpublished = {Summer School on Practice and Theory of Distributed Computing},
 year = 2019,
 note = "\url{https://www.youtube.com/watch?v=8-Bc5Lqgx_c&t=4398s}"
}

@Misc{pressler2019:loom-proposal,
 author = "Ron Pressler",
 title = "Project Loom: Fibers and Continuations for the Java Virtual Machine",
 howpublished = "\url{http://cr.openjdk.java.net/~rpressler/loom/Loom-Proposal.html}",
 year = 2019,
 note = {Accessed: 2020-10-15}
}

@Misc{pressler2020:state-of-loom,
 author = "Ron Pressler",
 title = "State of Loom",
 howpublished = "\url{http://cr.openjdk.java.net/~rpressler/loom/loom/sol1_part1.html}",
 year = 2020,
 note = {Accessed: 2020-10-15}
}

@Misc{r7rs,
 author = {Alex Shinn and John Cowan and Arthur A. Gleckler (editors and Steven Ganz and Alexey Radul and Olin Shivers and Aaron W. Hsu and Jeffrey T. Read and Alaric Snell-pym and Bradley Lucier and David Rush and Gerald J. Sussman and Emmanuel Medernach and Benjamin L. Russel and Richard Kelsey and William Clinger and Jonathan Rees and Michael Sperber},
 title = {Revised 7 Report on the Algorithmic Language Scheme},
 month = 7,
 year = 2013,
 note = "\url{https://small.r7rs.org/attachment/r7rs.pdf}",
 number = "R7RS"
}

@Article{rapid-prototyping,
 author = {Gordon, V. Scott and Bieman, James M.},
 title = {Rapid Prototyping: Lessons Learned},
 journal = {IEEE Softw.},
 year = 1995,
 volume = 12,
 number = 1,
 pages = {85–95},
 month = jan,
 issue_date = {January 1995},
 publisher = {IEEE Computer Society Press},
 address = {Washington, DC, USA},
 issn = {0740-7459},
 url = {https://doi.org/10.1109/52.363162},
 doi = {10.1109/52.363162},
 numpages = 11,
 keywords = {rapid prototyping, process attributes, evolutionary software development, quality attributes, software lifecycle models, industrial software}
}

@InProceedings{rapid-prototyping-initial-thoughts,
 author = {Taylor, Tamara and Standish, Thomas A.},
 title = {Initial Thoughts on Rapid Prototyping Techniques},
 booktitle = {Proceedings of the Workshop on Rapid Prototyping},
 year = 1982,
 pages = {160–166},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = {089791094X},
 url = {https://doi.org/10.1145/1006259.1006286},
 doi = {10.1145/1006259.1006286},
 numpages = 7,
 location = {Columbia, Maryland}
}

@PhdThesis{robust-composition,
 author = {Mark Samuel Miller},
 title = {Robust Composition: Towards a Unified Approach to Access Control and Concurrency Control},
 school = {Johns Hopkins University},
 year = 2006
}

@Article{scratch-programming-for-all,
 author = {Resnick, Mitchel and Maloney, John and Monroy-Hern\'{a}ndez, Andr\'{e}s and Rusk, Natalie and Eastmond, Evelyn and Brennan, Karen and Millner, Amon and Rosenbaum, Eric and Silver, Jay and Silverman, Brian and Kafai, Yasmin},
 title = {Scratch: Programming for All},
 journal = {Commun. ACM},
 year = 2009,
 volume = 52,
 number = 11,
 pages = {60–67},
 month = nov,
 issue_date = {November 2009},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {0001-0782},
 url = {https://doi.org/10.1145/1592761.1592779},
 doi = {10.1145/1592761.1592779},
 numpages = 8
}

@Article{secd,
 author = {Peter J. Landin},
 title = "{The Mechanical Evaluation of Expressions}",
 journal = {The Computer Journal},
 year = 1964,
 volume = 6,
 number = 4,
 pages = {308-320},
 month = 1,
 issn = {0010-4620},
 doi = {10.1093/comjnl/6.4.308}
}

@Misc{self-handbook,
 author = {Russel Allen and Ole Agesen and Lars Bak and Craig Chambers and Bay-Wei Chang and Urs Hölzle and John Maloney and Tobias Pape and Randall B. Smith and David Ungar and Mario Wolczko},
 title = "Self Handbook Documentation",
 howpublished = "\url{https://handbook.selflanguage.org}",
 month = may,
 year = 2017,
 notes = "Accessed: 2020-10-09"
}

@Misc{sicl-specification,
 author = {Robert Strandh},
 title = "{SICL} {B}uilding blocks for creators of {C}ommon {L}isp implementations.",
 howpublished = "\url{http://metamodular.com/SICL/sicl-specification.pdf}, Accessed: 2020-10-15",
 year = 2013
}

@PhdThesis{sista-thesis,
 author = {Béra, Clément},
 title = {Sista: a Metacircular Architecture for Runtime Optimisation Persistence},
 school = {Université de Lille},
 year = 2017,
 month = 09,
 note = "\url{https://hal.inria.fr/tel-01634137/}"
}

@Article{smalltalk-design,
 author = {Ingalls, Daniel},
 title = {Design Principles Behind {Smalltalk}},
 journal = {BYTE},
 year = 1981,
 volume = 6,
 number = 8,
 pages = {286–299},
 month = 8,
 note = "\url{https://www.cs.virginia.edu/~evans/cs655/readings/smalltalk.html}, \url{https://archive.org/details/byte-magazine-1981-08/page/n299/mode/2up}",
 issue_date = {Aug. 1981},
 publisher = {McGraw-Hill, Inc.},
 address = {USA},
 issn = {0360-5280},
 numpages = 13
}

@Book{sml,
 author = {Milner, Robin and Harper, Robert and Tofte, Mads},
 title = {The definition of {Standard ML}},
 publisher = {The MIT Press},
 year = 1990
}

@InProceedings{termite-scheme,
 author = {Germain, Guillaume},
 title = {Concurrency Oriented Programming in Termite Scheme},
 booktitle = {Proceedings of the 2006 ACM SIGPLAN Workshop on Erlang},
 year = 2006,
 series = {ERLANG '06},
 pages = 20,
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 1595934901,
 url = {https://doi.org/10.1145/1159789.1159795},
 doi = {10.1145/1159789.1159795},
 numpages = 1,
 keywords = {continuations, macros, erlang, distributed computing, scheme},
 location = {Portland, Oregon, USA}
}

@Book{the-common-lisp-condition-system,
 author = {Herda, Michał},
 title = {The Common Lisp Condition System},
 publisher = {Apress, Berkeley, CA},
 year = 2020,
 isbn = {978-1-4842-6134-7},
 doi = {10.1007/978-1-4842-6134-7}
}

@Article{thomson200185,
 author = {Alan J Thomson and Daniel L Schmoldt},
 title = {Ethics in computer software design and development},
 journal = {Computers and Electronics in Agriculture},
 year = 2001,
 volume = 30,
 number = 1,
 pages = {85-102},
 issn = {0168-1699},
 doi = {https://doi.org/10.1016/S0168-1699(00)00158-7},
 url = {https://www.sciencedirect.com/science/article/pii/S0168169900001587},
 keywords = {Ethics, Software design and development, Traditional ecological knowledge, Indigenous knowledge, Intellectual property, Information ecologies}
}

@InProceedings{two-decades-of-st-debugging,
 author = {Miranda, Eliot and B\'{e}ra, Cl\'{e}ment and Boix, Elisa Gonzalez and Ingalls, Dan},
 title = {Two Decades of Smalltalk VM Development: Live VM Development through Simulation Tools},
 booktitle = {Proceedings of the 10th ACM SIGPLAN International Workshop on Virtual Machines and Intermediate Languages},
 year = 2018,
 series = {VMIL 2018},
 pages = {57–66},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 9781450360715,
 url = {https://doi.org/10.1145/3281287.3281295},
 doi = {10.1145/3281287.3281295},
 numpages = 10,
 keywords = {live development, garbage collector, Just-in-Time compiler, virtual machine, tools, managed runtime},
 location = {Boston, MA, USA}
}

@InProceedings{ungar2005:klein,
 author = {Ungar, David and Spitz, Adam and Ausch, Alex},
 title = {Constructing a Metacircular Virtual Machine in an Exploratory Programming Environment},
 booktitle = {Companion to the 20th Annual ACM SIGPLAN Conference on Object-Oriented Programming, Systems, Languages, and Applications},
 year = 2005,
 series = {OOPSLA '05},
 pages = {11–20},
 address = {New York, NY, USA},
 publisher = {Association for Computing Machinery},
 isbn = 1595931937,
 url = {https://doi.org/10.1145/1094855.1094865},
 doi = {10.1145/1094855.1094865},
 numpages = 10,
 keywords = {meta-recursive, fix-and-continue, object oriented, remote reflection, code reuse, mirror-based reflection, liveness, virtual machine, reactivity, exploratory programming, Klein, metacircularity, lenses, prototypes, self, debugger},
 location = {San Diego, CA, USA}
}

@Article{unrolling-lists,
 author = {Shao, Zhong and Reppy, John H. and Appel, Andrew W.},
 title = {Unrolling Lists},
 journal = {SIGPLAN Lisp Pointers},
 year = 1994,
 volume = {VII},
 number = 3,
 pages = {185–195},
 month = 7,
 issue_date = {July-Sept. 1994},
 publisher = {Association for Computing Machinery},
 address = {New York, NY, USA},
 issn = {1045-3563},
 url = {https://doi.org/10.1145/182590.182453},
 doi = {10.1145/182590.182453},
 numpages = 11
}

@Article{value-class-optimisation,
 author = {Tobias Pape and Carl Friedrich Bolz and Robert Hirschfeld},
 title = {Adaptive just-in-time value class optimization for lowering memory consumption and improving execution time performance},
 journal = {Science of Computer Programming},
 year = 2017,
 volume = 140,
 pages = {17--29},
 month = 6,
 doi = {10.1016/j.scico.2016.08.003},
 url = {https://doi.org/10.1016\%2Fj.scico.2016.08.003},
 publisher = {Elsevier {BV}}
}

@Article{wolczko96:towards,
 author = {Mario Wolczko and Ole Agesen and David Ungar},
 title = {Towards a Universal Implementation Substrate for Object-Oriented Languages},
 journal = {Proceedings of the Workshop on Simplicity, Performance and Portability in Virtual Machine Design},
 year = 1999,
 note = "\url{https://www.researchgate.net/publication/2398949_Towards_a_Universal_Implementation_Substrate_for_Object-Oriented_Languages}, Accessed: 2020-10-15"
}

@InProceedings{wolczko:self-includes-smalltalk,
 author = {Mario Wolczko},
 title = {self includes: Smalltalk},
 booktitle = {Workshop on Prototype-Based Languages},
 year = 1996,
 month = aug,
 note = "\url{https://www.researchgate.net/publication/265807184_self_includes_Smalltalk}",
 journal = {ECOOP'96},
 location = {Linz, Austria}
}
